/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_DEBUG_H
#define _NEST_DEBUG_H

#include "nest_common.h"
#include "nest_error.h"
#include "nest_protocol.h"

//** Only "awlays"
#define NEST_DEBUG_MIN              0x00000001

//** concurrencies
#define NEST_DEBUG_CONCURRENCY      0x00000002

//** miscellaneous
#define NEST_DEBUG_FLOCK            0x00000010
#define NEST_DEBUG_MALLOC           0x00000020

//** account management
#define NEST_DEBUG_USER_MNGMNT      0x00000100
#define NEST_DEBUG_GROUP_MNGMNT     0x00000200
#define NEST_DEBUG_ACCT_MNGMNT      0x00000300

//** reservations
#define NEST_DEBUG_LOTS             0x00000400

//** more miscellaneous
#define NEST_DEBUG_ACL              0x00001000
#define NEST_DEBUG_DEBUG            0x00004000
#define NEST_DEBUG_TRANSFER         0x00008000

#define NEST_DEBUG_CLIENT           0x00010000
#define NEST_DEBUG_STORAGE          0x00020000
#define NEST_DEBUG_SERVER           0x00040000
#define NEST_DEBUG_ADMIN            0x00080000

#define NEST_DEBUG_AUTH             0x00100000
#define NEST_DEBUG_FD		        0x00400000
#define NEST_DEBUG_PROXY            0x00800000

//** protocols
#define NEST_DEBUG_PROTOCOL_SCHED   0x01000000
#define NEST_DEBUG_CHIRP            0x02000000
#define NEST_DEBUG_HTTP             0x04000000
#define NEST_DEBUG_PROTOCOL         0x0f000000

#define NEST_DEBUG_ALWAYS           0xffffffff
#define NEST_DEBUG_NEVER            0x00000000

// used to turn debugging on or off
void set_nest_debug_level( long level );
void add_nest_debug_level( long new_level );
NestReplyStatus add_nest_debug_level( const char *debug );
bool check_nest_debug_status( long level );

NestReplyStatus nest_debug_init( nestProtocol *, bool daemonize );

long get_nest_debug_level( );

int nest_debug( long level, const char *fmt, ...);
void nest_perror( const char *msg);
int nest_printf( const char *fmt, ... ); 
int nest_warn( const char *filename, const char *func_name, const char *fmt, ... );
void nest_die( const char *fmt, ... );

#endif
