/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_DEVICE_MANAGER_H_
#define _NEST_DEVICE_MANAGER_H_

#include "nest_arch_specific.h"

#include "nest_common.h"
#include "nest_device.h"

class DeviceManager
{
  private:
	ClassAdCollection       *devices;

	ViewName                devices_view;
	ClassAdParser           parser;
	ClassAdUnParser         unparser;
	LocalCollectionQuery    query;

	NestDevice               *device;

	int add_entry( NestDevice *d );
	NestDevice *get_entry( const char *dev );

  public:
	DeviceManager();
	~DeviceManager();

	// Get R/O disk entry
	const NestDevice *get_device_entry( const char *dev );
	const NestDevice *get_best_device( );

	nestLotSize free_space(const char *dev,
						   int is_user);

	nestLotSize free_space(int is_user);

	int incr_usage(const char *dev,
				   nestLotSize size,
				   int is_user);

	int decr_usage(const char *dev,
				   nestLotSize size,
				   int is_user);

	NestReplyStatus initialize(ClassAdCollection *resources,
							   const char *dev );

	NestReplyStatus recover(ClassAdCollection *resources );

	NestReplyStatus synchronize();
	NestReplyStatus shutdown();

};


#endif
