/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_DSI_SEND_H
#define NEST_DSI_SEND_H

#include "nest_speak.h"
#include "nest_dsi_transfer.h"
extern "C" {
#include "globus_gridftp_server.h"
}

class nestDsiSend : public nestDsiTransfer
{
  public:
	nestDsiSend( nestDsiSession *session,
				 globus_gfs_transfer_info_t *info );
	~nestDsiSend( void );

	// Methods to do the actual transfer & related things
	int setup( globus_gfs_operation_t			op,
			   globus_gridftp_server_write_cb_t	callback );
	int writeCB( globus_gfs_operation_t	op,
				 globus_result_t		result,
				 globus_byte_t			*buffer,
				 globus_size_t			nbytes );
	int readFromNest( globus_size_t &nbytes );
	int getBufferBytes( void ) { return bytesInBuffer; };

  private:
	long	offset;
	int		bytesInBuffer;
};


#endif
