/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_ERROR_H
#define _NEST_ERROR_H

// HEY HEY HEY
// If you change these, you must change nest_error_list in the .C file also
enum NestReplies {
    NEST_SUCCESS,                   // 0
    NEST_LOCAL_FILE_NOT_FOUND,      // 1
    NEST_REMOTE_FILE_NOT_FOUND,     // 2
    NEST_INSUFFICIENT_SPACE,        // 3
    NEST_NO_CONNECTION,             // 4
    NEST_BAD_PARAMETERS,            // 5
    NEST_NOT_YET_IMPLEMENTED,       // 6
    NEST_UNKNOWN_REQUEST_TYPE,      // 7
    NEST_NONPRIVELEDGED_USER,       // 8
    NEST_UNKNOWN_USER,              // 9
    NEST_NONPRIVELEDGED_SERVER,     // 10
    NEST_ALREADY_EXISTS,            // 11
    NEST_NOT_EMPTY,                 // 12
    NEST_PARTIAL_MESSAGE,           // 13
    NEST_UNKNOWN_ERROR,             // 14
    NEST_TEMPORARILY_UNAVAILABLE,   // 15
    NEST_UNKNOWN_DEBUG_VALUE,       // 16
    NEST_INVALID_AUTHENTICATION,    // 17
    NEST_COULD_NOT_AUTHENTICATE,    // 18

    NEST_OUT_OF_RESOURCES,          // 19
    NEST_SYSTEM_FILE_MISSING,       // 20

    NEST_FILE_EXISTS,               // 21
    NEST_FILE_NOT_FOUND,            // 22
    NEST_TOO_MANY_LINKS,            // 23
    NEST_FILENAME_TOO_LONG,         // 24

    NEST_USER_EXISTS,				// 25
    NEST_USER_NOT_FOUND,            // 26
    NEST_USER_LIMIT_REACHED,        // 27

    NEST_GROUP_EXISTS,				// 28
    NEST_GROUP_NOT_FOUND,			// 29
    NEST_GROUP_LIMIT_REACHED,		// 30
    NEST_GROUP_ACTIVE,				// 31

    NEST_DISK_FULL,                 // 32
    NEST_NO_QUOTA_ENFORCEMENT,		// 33
    NEST_QUOTA_ENFORCEMENT_ERROR,	// 34

    NEST_LOT_SCHEDULED,             // 35
    NEST_LOT_NOT_FOUND,				// 36
    NEST_LOT_NOT_ENOUGH,			// 37
    NEST_LOT_NOT_EMPTY,				// 38
    NEST_LOT_LIMIT_REACHED,			// 39
    NEST_LOT_INVALID,				// 40
    NEST_LOT_DISABLED,				// 41

    NEST_CLASSAD_ERROR,             // 42

    NEST_STALE_FH,                  // 43
    NEST_INTR,						// 44
    NEST_FLOCK,                     // 45

    NEST_SYSTEM_FILE_UPDATE_FAILED, // 46
    NEST_LOT_UPDATE_FAILED,         // 47

    NEST_INCONSISTENT_STATE,        // 48         
    NEST_NOT_YET_INITIALIZED,       // 49
    NEST_NOT_A_FILE,                // 50

	NEST_BAD_COLLECTION,			// 51
    NEST_NOT_DIRECTORY,             // 52
	
    NEST_ERROR_MAX                  // This must be the last error
                                    //  in the list.
};

typedef int NestReplyStatus;

NestReplyStatus ErrnoToNest( int error );

int NestToErrno( NestReplyStatus );

const char * NestErrorString( NestReplyStatus error );    

#endif
