/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_FILETRANSFER_H 
#define _NEST_FILETRANSFER_H 

#include "nest_common.h"
#include "nest_protocol.h"
#include "nest_request.h"


struct IO_Measurement
{
    unsigned long total_bytes;

    unsigned long total_in_time;
    unsigned long total_out_time;

    unsigned int  first_in_time;
    unsigned int  first_out_time;
    unsigned int  first_in_size;
    unsigned int  first_out_size;
};

class nestFiletransfer
{

public:

    nestFiletransfer( nestProtocol *src, nestProtocol *dst, long length, 
            char *buffer, long bufsize, int type ); 

    ~nestFiletransfer( );

    bool isIncoming();
    
    void setLimit( long allocation );
        
    long getLimit( );
    
    NestReplyStatus BlockingTransfer( );
    
    NestReplyStatus startTransfer( );

    NestReplyStatus endTransfer( NestReplyStatus status );

    nestProtocol *getSrc( ) { return src; }

    nestProtocol *getDst( ) { return dst; }
    
    struct IO_Measurement *getMeasurements();
    
    void setMeasurements( struct IO_Measurement *measurements );

    long getLength( ) { return initlen; }

    long getInitialLength( );
    
    long getBytesTransferred( );

    void setBytesTransferred( long bytes );

    float getBandwidth( );

    long getLatency( );

    int getType( );

    void setCacheGuess( bool b ) { cache_guess = b; }

    bool getCacheGuess( ) { return cache_guess; }

    void setLengthGuess( long len ) { len_guess = len; }

    long getLengthGuess( ) { return len_guess; }

private:

    nestProtocol *src;
    nestProtocol *dst;
    char *buffer;
    long buflength;
    long initlen;
    long allocation;
    struct timeval start, *end;
    int type;
    struct IO_Measurement info; 
    long len_guess;
    bool cache_guess;
    bool started;
};

#endif



