/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_HASH_TABLE_H
#define NEST_HASH_TABLE_H

#include "nest_common.h"

struct nest_hash_table * nest_hash_table_create( 
        int buckets, int (*hashfunc)( const char * ) );

void nest_hash_table_delete( struct nest_hash_table *h );

void * nest_hash_table_lookup( struct nest_hash_table *h, const char *key );

int nest_hash_table_insert( 
        struct nest_hash_table *h, const char *key, void *value );

int nest_hash_table_remove( struct nest_hash_table *h, const char *key );

int nest_hash_table_size( struct nest_hash_table *h );

// iterator function can return 0 to stop the iteration. 
int nest_hash_table_iterate( struct nest_hash_table *h, 
        int (*iterator) ( const char *key, void *item, void *arg ), void *arg );

int nest_hash_string( char *s );

int nest_hash_int( char *s );

#endif
