/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_PROTOCOL_STORAGE_H
#define _NEST_PROTOCOL_STORAGE_H

#include "nest_common.h"
#include "nest_protocol.h"
//#include "nest_client.h"

class nestProtocolStorage: public nestProtocol
{

public:

    virtual bool sendErrorMessage( const char* filename, const char* func_name, int error );

    virtual bool sendAck( );

    virtual nestRequest* receiveRequest( void );

    virtual bool sendFilesize( nestFileSize size );


    virtual int  set_filenames(char *logical_name, char *physical_name);

    virtual int  get_filenames(char *logical_name, char *physical_name);


    virtual int  set_open_flags(int flags);

    virtual int  get_open_flags(int *flags);


    virtual int  set_open_filesize(nestFileSize size);

    virtual int  get_open_filesize(nestFileSize *size);


    virtual int  set_ids(user_id_t uid, user_id_t gid);

    virtual int  get_ids(user_id_t *uid, user_id_t *gid);

    virtual int set_fdkey( const char *fdkey );

    virtual void set_fd_cache_status( bool status );

    virtual bool get_fd_cache_status( );

	const char *getName( void ) { return "Storage"; };

};
#endif
