/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#ifndef _NEST_PROXY_FETCH_H
#define _NEST_PROXY_FETCH_H

#include "nest_common.h"

class nestClient;

class
nestProxyFetch {

public:

    nestProxyFetch(     const char *homefile,     // file on home node
                        const char *proxyfile,    // file on proxy node
                        const char *shadowname,   // shadow name on proxy node
                        long  homefile_offset,
                        long  homefile_length,
						nestClient *client,
                        bool forwarded_req = false);   
                                                // is client themselves a proxy

    ~nestProxyFetch( );

    const char* getServer( );
    const char* getHomeFile();
    const char* getProxyFile();

	const nestClient *getClient( );
	const char *getClientHostName( void );
	const char *getClientHostIdentity( void );
    const nestUser *getClientUser();
    const char *getClientCwd();

    const char *getShadowFile();

    long getHomeOffset();
    long getHomeLength();

    int  getAttempts();
    bool wasForwarded();

    void setStatus( NestReplyStatus status );
    void incrementAttempts();
    void setServer( const char *server );

private:
    int attempts;

    char *homefile;
    char *proxyfile;
    char *shadowfile;
    char *server;
	nestClient *client;

    long home_off;
    long home_len;

    bool forwarded;
};

#endif
