/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_PTHREAD_UTIL_h
#define NEST_PTHREAD_UTIL_h

#ifdef USE_PTHREADS

#include<pthread.h>

extern pthread_mutex_t nest_common_mutex;
extern pthread_mutex_t nest_malloc_mutex;
extern pthread_mutex_t nest_strdup_mutex;
#define LOCK_MUTEX(x)     lockCommonMutex( x, __FILE__, __LINE__ );
#define UNLOCK_MUTEX(x) unlockCommonMutex( x, __FILE__, __LINE__ );

int nest_pthread_mutex_init(pthread_mutex_t *,const pthread_mutexattr_t *);
int nest_pthread_cond_init(pthread_cond_t *cond,const pthread_condattr_t *attr);
int nest_pthread_cond_destroy(pthread_cond_t *cond);
int nest_pthread_mutex_lock(pthread_mutex_t *mp);
int nest_pthread_mutex_unlock(pthread_mutex_t *mp);
int nest_pthread_mutex_destroy(pthread_mutex_t *mp);
int nest_pthread_cond_wait( pthread_cond_t *cvp, pthread_mutex_t *mp );
int nest_pthread_cond_timedwait(pthread_cond_t *cvp, pthread_mutex_t *mp,
               struct timespec *abstime);
int nest_pthread_cond_signal(pthread_cond_t *cond);
int nest_pthread_cond_broadcast(pthread_cond_t *cond);
int nest_pthread_create(pthread_t *new_thread_ID, const pthread_attr_t *attr,
           void * (*start_func)(void *), void *arg);
int nest_pthread_attr_init(pthread_attr_t *attr);
int nest_pthread_attr_setscope(pthread_attr_t *attr, int contentionscope);
int nest_pthread_attr_setschedpolicy(pthread_attr_t *attr, int policy);

#else
#define LOCK_MUTEX(x)
#define UNLOCK_MUTEX(x)

#endif

#endif
